package ru.landgrafhomyak.db.sql_skeleton_0.api.misc

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.raw.DialectKey
import ru.landgrafhomyak.db.sql_skeleton_0.api.raw.DialectResolver
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.RowId
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.Table

public interface DatabaseType<
		RUNTIME_TYPE : Any?,
		in DESCRIPTOR_SCOPE : Any,
		out NATIVE_DESCRIPTOR : Any,
		in GETTER_SCOPE : Any,
		in SETTER_SCOPE : Any
		> {
	public enum class RowIdSize {
		VERY_SMALL,
		SMALL,
		NORMAL
	}

	public fun _nativeDescriptor(scope: DESCRIPTOR_SCOPE): NATIVE_DESCRIPTOR

	public fun _get(scope: GETTER_SCOPE, columnIndex: Int): RUNTIME_TYPE

	public fun _set(scope: SETTER_SCOPE, paramIndex: Int, value: RUNTIME_TYPE)

	public val nullable: DatabaseType<RUNTIME_TYPE?, DESCRIPTOR_SCOPE, NATIVE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getName")
	public val name: String


	public interface DefaultTypes<
			in DESCRIPTOR_SCOPE : Any,
			out NATIVE_DESCRIPTOR : Any,
			in GETTER_SCOPE : Any,
			in SETTER_SCOPE : Any
			> {
		@Suppress("INAPPLICABLE_JVM_NAME", "PropertyName")
		@get:JvmName("BOOLEAN")
		public val BOOLEAN: DatabaseType<Boolean, DESCRIPTOR_SCOPE, NATIVE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>

		@OptIn(ExperimentalUnsignedTypes::class)
		@Suppress("INAPPLICABLE_JVM_NAME", "PropertyName")
		@get:JvmName("BINARY_DATA")
		public val BINARY_DATA: DatabaseType<UByteArray, DESCRIPTOR_SCOPE, NATIVE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>

		@OptIn(ExperimentalUnsignedTypes::class)
		public fun BINARY_DATA(size: UInt, isFixedSize: Boolean): DatabaseType<UByteArray, DESCRIPTOR_SCOPE, NATIVE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>

		public fun <RUNTIME_TYPE, DATABASE_TYPE : DatabaseType<RUNTIME_TYPE, @UnsafeVariance DESCRIPTOR_SCOPE, @UnsafeVariance NATIVE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE>> custom(
			resolver: DialectResolver<
					DialectKey<*, @UnsafeVariance DESCRIPTOR_SCOPE, @UnsafeVariance NATIVE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE>,
					DATABASE_TYPE
					>
		): DATABASE_TYPE
	}
}
