package ru.landgrafhomyak.db.sql_skeleton_0.api.queries

import ru.landgrafhomyak.db.sql_skeleton_0.api.misc.Column
import ru.landgrafhomyak.db.sql_skeleton_0.api.misc.DatabaseType
import ru.landgrafhomyak.db.sql_skeleton_0.api.misc.QueryParam

public interface RawStatement<out qUE : Any> {
	public val uExt: qUE

	public interface _InputConstructorScope<
			QUERY_USER_EXTENSION : Any,
			in TYPE_SCOPE : Any?,
			out TYPE_DESCRIPTOR : Any,
			in GETTER_SCOPE : Any,
			in SETTER_SCOPE : Any
			> {
		public val types: DatabaseType.DefaultTypes<TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		public fun <RT, DT : DatabaseType<RT, @UnsafeVariance TYPE_SCOPE, @UnsafeVariance TYPE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE>> inputParam(type: DT, paramIndex: UInt, vararg duplicateIndices: UInt): QueryParam<RT, DT, QUERY_USER_EXTENSION>
	}

	public interface _OutputConstructorScope<
			QUERY_USER_EXTENSION : Any,
			in TYPE_SCOPE : Any?,
			out TYPE_DESCRIPTOR : Any,
			in GETTER_SCOPE : Any,
			in SETTER_SCOPE : Any
			> {
		public val types: DatabaseType.DefaultTypes<TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		public fun <RT, DT : DatabaseType<RT, @UnsafeVariance TYPE_SCOPE, @UnsafeVariance TYPE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE>> outputColumn(type: DT, columnIndex: UInt): Column<RT, DT, QUERY_USER_EXTENSION>
	}

	public interface _IOConstructorScope<
			QUERY_USER_EXTENSION : Any,
			in TYPE_SCOPE : Any?,
			out TYPE_DESCRIPTOR : Any,
			in GETTER_SCOPE : Any,
			in SETTER_SCOPE : Any
			> : _InputConstructorScope<QUERY_USER_EXTENSION, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>,
		_OutputConstructorScope<QUERY_USER_EXTENSION, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE> {
		public override val types: DatabaseType.DefaultTypes<TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
	}


	public interface Void2Void : _Statement.Void2Void {
		public interface Constructor<in STATEMENT_SCOPE : Any?, out RAW_STATEMENT : Any> {
			public fun createRawStatement_void2void(scope: STATEMENT_SCOPE): RAW_STATEMENT
		}
	}

	public interface Void2Row<QUERY_USER_EXTENSION : Any> : _Statement.Void2Row<QUERY_USER_EXTENSION> {
		override val uExt: QUERY_USER_EXTENSION

		public interface Constructor<
				out QUERY_USER_EXTENSION : Any,
				in STATEMENT_SCOPE : Any?,
				out RAW_STATEMENT : Any,
				in TYPE_SCOPE : Any?,
				out TYPE_DESCRIPTOR : Any,
				in GETTER_SCOPE : Any,
				in SETTER_SCOPE : Any
				> {
			public fun createRawStatement_void2row(scope: STATEMENT_SCOPE): RAW_STATEMENT

			public fun linkRawStatement_void2row(
				scope: _OutputConstructorScope<
						@UnsafeVariance QUERY_USER_EXTENSION, @UnsafeVariance TYPE_SCOPE, @UnsafeVariance TYPE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE
						>
			): QUERY_USER_EXTENSION
		}
	}

	public interface Void2RowOrNull<QUERY_USER_EXTENSION : Any> : _Statement.Void2RowOrNull<QUERY_USER_EXTENSION> {
		override val uExt: QUERY_USER_EXTENSION

		public interface Constructor<
				out QUERY_USER_EXTENSION : Any,
				in STATEMENT_SCOPE : Any?,
				out RAW_STATEMENT : Any,
				in TYPE_SCOPE : Any?,
				out TYPE_DESCRIPTOR : Any,
				in GETTER_SCOPE : Any,
				in SETTER_SCOPE : Any
				> {
			public fun createRawStatement_void2rowOrNull(scope: STATEMENT_SCOPE): RAW_STATEMENT

			public fun linkRawStatement_void2rowOrNull(
				scope: _OutputConstructorScope<
						@UnsafeVariance QUERY_USER_EXTENSION, @UnsafeVariance TYPE_SCOPE, @UnsafeVariance TYPE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE
						>
			): QUERY_USER_EXTENSION
		}
	}

	public interface Void2Table<QUERY_USER_EXTENSION : Any> : _Statement.Void2Table<QUERY_USER_EXTENSION> {
		override val uExt: QUERY_USER_EXTENSION

		public interface Constructor<
				out QUERY_USER_EXTENSION : Any,
				in STATEMENT_SCOPE : Any?,
				out RAW_STATEMENT : Any,
				in TYPE_SCOPE : Any?,
				out TYPE_DESCRIPTOR : Any,
				in GETTER_SCOPE : Any,
				in SETTER_SCOPE : Any
				> {
			public fun createRawStatement_void2table(scope: STATEMENT_SCOPE): RAW_STATEMENT

			public fun linkRawStatement_void2table(
				scope: _OutputConstructorScope<
						@UnsafeVariance QUERY_USER_EXTENSION, @UnsafeVariance TYPE_SCOPE, @UnsafeVariance TYPE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE
						>
			): QUERY_USER_EXTENSION
		}
	}

	public interface Params2Void<QUERY_USER_EXTENSION : Any> : _Statement.Params2Void<QUERY_USER_EXTENSION> {
		public interface Constructor<
				out QUERY_USER_EXTENSION : Any,
				in STATEMENT_SCOPE : Any?,
				out RAW_STATEMENT : Any,
				in TYPE_SCOPE : Any?,
				out TYPE_DESCRIPTOR : Any,
				in GETTER_SCOPE : Any,
				in SETTER_SCOPE : Any
				> {
			public fun createRawStatement_params2void(scope: STATEMENT_SCOPE): RAW_STATEMENT

			public fun linkRawStatement_params2void(
				scope: _InputConstructorScope<
						@UnsafeVariance QUERY_USER_EXTENSION, @UnsafeVariance TYPE_SCOPE, @UnsafeVariance TYPE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE
						>
			): QUERY_USER_EXTENSION
		}
	}

	public interface Params2Row<QUERY_USER_EXTENSION : Any> : _Statement.Params2Row<QUERY_USER_EXTENSION> {
		public interface Constructor<
				out QUERY_USER_EXTENSION : Any,
				in STATEMENT_SCOPE : Any?,
				out RAW_STATEMENT : Any,
				in TYPE_SCOPE : Any?,
				out TYPE_DESCRIPTOR : Any,
				in GETTER_SCOPE : Any,
				in SETTER_SCOPE : Any
				> {
			public fun createRawStatement_params2row(scope: STATEMENT_SCOPE): RAW_STATEMENT

			public fun linkRawStatement_params2row(
				scope: _IOConstructorScope<
						@UnsafeVariance QUERY_USER_EXTENSION, @UnsafeVariance TYPE_SCOPE, @UnsafeVariance TYPE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE
						>
			): QUERY_USER_EXTENSION
		}
	}

	public interface Params2RowOrNull<QUERY_USER_EXTENSION : Any> : _Statement.Params2RowOrNull<QUERY_USER_EXTENSION> {
		public interface Constructor<
				out QUERY_USER_EXTENSION : Any,
				in STATEMENT_SCOPE : Any?,
				out RAW_STATEMENT : Any,
				in TYPE_SCOPE : Any?,
				out TYPE_DESCRIPTOR : Any,
				in GETTER_SCOPE : Any,
				in SETTER_SCOPE : Any
				> {
			public fun createRawStatement_params2rowOrNull(scope: STATEMENT_SCOPE): RAW_STATEMENT

			public fun linkRawStatement_params2rowOrNull(
				scope: _OutputConstructorScope<
						@UnsafeVariance QUERY_USER_EXTENSION, @UnsafeVariance TYPE_SCOPE, @UnsafeVariance TYPE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE
						>
			): QUERY_USER_EXTENSION
		}
	}

	public interface Params2Table<QUERY_USER_EXTENSION : Any> : _Statement.Params2Table<QUERY_USER_EXTENSION> {
		public interface Constructor<
				out QUERY_USER_EXTENSION : Any,
				in STATEMENT_SCOPE : Any?,
				out RAW_STATEMENT : Any,
				in TYPE_SCOPE : Any?,
				out TYPE_DESCRIPTOR : Any,
				in GETTER_SCOPE : Any,
				in SETTER_SCOPE : Any
				> {
			public fun createRawStatement_params2table(scope: STATEMENT_SCOPE): RAW_STATEMENT

			public fun linkRawStatement_params2table(
				scope: _OutputConstructorScope<
						@UnsafeVariance QUERY_USER_EXTENSION, @UnsafeVariance TYPE_SCOPE, @UnsafeVariance TYPE_DESCRIPTOR, @UnsafeVariance GETTER_SCOPE, @UnsafeVariance SETTER_SCOPE
						>
			): QUERY_USER_EXTENSION
		}
	}
}