package ru.landgrafhomyak.db.sql_skeleton_0.api.raw

import ru.landgrafhomyak.db.sql_skeleton_0.api.misc.DatabaseType as _DatabaseType
import ru.landgrafhomyak.db.sql_skeleton_0.api.queries.RawStatement as _RawQuery

public interface DialectResolver {
	public interface DatabaseType<RUNTIME_TYPE> {
		public suspend fun <
				TYPE_SCOPE : Any?,
				TYPE_DESCRIPTOR : Any,
				GETTER_SCOPE : Any,
				SETTER_SCOPE : Any
				> resolveDatabaseTypeByDialect(
			key: DialectKey<*, *, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		): _DatabaseType<RUNTIME_TYPE, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
	}

	public interface RawQuery_Void2Void {
		public suspend fun <
				STATEMENT_SCOPE : Any?,
				RAW_STATEMENT : Any
		> resolveDatabaseTypeByDialect(
			key: DialectKey<STATEMENT_SCOPE, RAW_STATEMENT, *, *, *, *>
		): _RawQuery.Void2Void.Constructor<STATEMENT_SCOPE, RAW_STATEMENT>
	}

	public interface RawQuery_Void2Row<out QUERY_USER_EXTENSION : Any> {
		public suspend fun <
				STATEMENT_SCOPE : Any?,
				RAW_STATEMENT : Any,
				TYPE_SCOPE : Any?,
				TYPE_DESCRIPTOR : Any,
				GETTER_SCOPE : Any,
				SETTER_SCOPE : Any
		> resolveDatabaseTypeByDialect(
			key: DialectKey<STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		): _RawQuery.Void2Row.Constructor<QUERY_USER_EXTENSION, STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
	}

	public interface RawQuery_Void2RowOrNull<out QUERY_USER_EXTENSION : Any> {
		public suspend fun <
				STATEMENT_SCOPE : Any?,
				RAW_STATEMENT : Any,
				TYPE_SCOPE : Any?,
				TYPE_DESCRIPTOR : Any,
				GETTER_SCOPE : Any,
				SETTER_SCOPE : Any
		> resolveDatabaseTypeByDialect(
			key: DialectKey<STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		): _RawQuery.Void2RowOrNull.Constructor<QUERY_USER_EXTENSION, STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
	}

	public interface RawQuery_Void2Table<out QUERY_USER_EXTENSION : Any> {
		public suspend fun <
				STATEMENT_SCOPE : Any?,
				RAW_STATEMENT : Any,
				TYPE_SCOPE : Any?,
				TYPE_DESCRIPTOR : Any,
				GETTER_SCOPE : Any,
				SETTER_SCOPE : Any
		> resolveDatabaseTypeByDialect(
			key: DialectKey<STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		): _RawQuery.Void2Table.Constructor<QUERY_USER_EXTENSION, STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
	}
	public interface RawQuery_Params2Void<out QUERY_USER_EXTENSION : Any> {
		public suspend fun <
				STATEMENT_SCOPE : Any?,
				RAW_STATEMENT : Any,
				TYPE_SCOPE : Any?,
				TYPE_DESCRIPTOR : Any,
				GETTER_SCOPE : Any,
				SETTER_SCOPE : Any
		> resolveDatabaseTypeByDialect(
			key: DialectKey<STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		): _RawQuery.Params2Void.Constructor<QUERY_USER_EXTENSION, STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
	}

	public interface RawQuery_Params2Row<out QUERY_USER_EXTENSION : Any> {
		public suspend fun <
				STATEMENT_SCOPE : Any?,
				RAW_STATEMENT : Any,
				TYPE_SCOPE : Any?,
				TYPE_DESCRIPTOR : Any,
				GETTER_SCOPE : Any,
				SETTER_SCOPE : Any
		> resolveDatabaseTypeByDialect(
			key: DialectKey<STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		): _RawQuery.Params2Row.Constructor<QUERY_USER_EXTENSION, STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
	}
	public interface RawQuery_Params2RowOrNull<out QUERY_USER_EXTENSION : Any> {
		public suspend fun <
				STATEMENT_SCOPE : Any?,
				RAW_STATEMENT : Any,
				TYPE_SCOPE : Any?,
				TYPE_DESCRIPTOR : Any,
				GETTER_SCOPE : Any,
				SETTER_SCOPE : Any
		> resolveDatabaseTypeByDialect(
			key: DialectKey<STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		): _RawQuery.Params2RowOrNull.Constructor<QUERY_USER_EXTENSION, STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
	}

	public interface RawQuery_Params2Table<out QUERY_USER_EXTENSION : Any> {
		public suspend fun <
				STATEMENT_SCOPE : Any?,
				RAW_STATEMENT : Any,
				TYPE_SCOPE : Any?,
				TYPE_DESCRIPTOR : Any,
				GETTER_SCOPE : Any,
				SETTER_SCOPE : Any
		> resolveDatabaseTypeByDialect(
			key: DialectKey<STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
		): _RawQuery.Params2Table.Constructor<QUERY_USER_EXTENSION, STATEMENT_SCOPE, RAW_STATEMENT, TYPE_SCOPE, TYPE_DESCRIPTOR, GETTER_SCOPE, SETTER_SCOPE>
	}
}